unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ImgList, ToolWin, ComCtrls, StdCtrls, ExtCtrls, ActnList, Buttons,
  Grids, IniFiles, ValEdit;

type
  TdescID = record
  ID: Integer;
  Decription: String;
end;

type
  TfrmMain = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Panel1: TPanel;
    Help1: TMenuItem;
    ActionList1: TActionList;
    FTPort_Configure: TAction;
    Timer1: TTimer;
    FTSendFile: TAction;
    FTReceiveFile: TAction;
    FTQuit: TAction;
    FTResend: TAction;
    SndRxvCmp: TAction;
    Exit1: TMenuItem;
    Panel2: TPanel;
    Panel5: TPanel;
    Label7: TLabel;
    Label2: TLabel;
    editTag: TEdit;
    editMask: TEdit;
    Label8: TLabel;
    rb2_0A: TRadioButton;
    rb2_0B: TRadioButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel7: TPanel;
    Label12: TLabel;
    Panel8: TPanel;
    SpeedHelp: TSpeedButton;
    Oddelovac4: TBevel;
    CanMessPanel: TPanel;
    Panel10: TPanel;
    Label13: TLabel;
    lblMessCount: TLabel;
    Label1: TLabel;
    OpenDialog2: TOpenDialog;
    Label15: TLabel;
    lblMessError: TLabel;
    ReceiveBox: TGroupBox;
    Label5: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    lblTime: TLabel;
    lblID: TLabel;
    lblData: TLabel;
    TransmitBox: TGroupBox;
    btnTransmit0: TBitBtn;
    btnStop0: TBitBtn;
    editData: TEdit;
    editID: TEdit;
    Label6: TLabel;
    Label11: TLabel;
    editTime: TEdit;
    Label17: TLabel;
    PeriodBox: TCheckBox;
    Label18: TLabel;
    RTRBox: TCheckBox;
    Label19: TLabel;
    GroupBox2: TGroupBox;
    SaveDialog2: TSaveDialog;
    SaveDialog3: TSaveDialog;
    SaveDialog4: TSaveDialog;
    btnInit: TSpeedButton;
    btnClear: TSpeedButton;
    btnPause: TSpeedButton;
    btnStop: TSpeedButton;
    ShowFrame: TCheckBox;
    GroupBox8: TGroupBox;
    LowSpeed: TRadioButton;
    HighSpeed: TRadioButton;
    Panel13: TPanel;
    lblBitRate: TLabel;
    lblKbps: TLabel;
    ListeningCheckBox: TCheckBox;
    Panel14: TPanel;
    Label290: TLabel;
    OneWire: TRadioButton;
    OneWireType: TLabel;
    ComboSpeed: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FTReceiveFileExecute(Sender: TObject);
    procedure FTQuitExecute(Sender: TObject);
    procedure ReceiveCanData(Hour,Min,Sec,Msec: Integer; RTR: Boolean; ID,Count: Integer; Data: array of Byte);
    procedure TransmitCanData(MCx,Per,Sys: Integer; RTR: Boolean; ID,Count: Integer; bData: array of Byte);
    procedure DecodeMessage(Data: array of Byte);
    procedure CanCountClear;
    procedure SaveMessage(var MessData: array of Byte; Length: Integer);
    function CreateMessage(TypeMessage, LenData: Integer; DataArray: array of Byte): Boolean;
    function  MessIdent(var MessData: array of Byte; var MessDetect: array of Byte; var ActPos,NoPos: Integer; Length: Integer): Boolean;
    function MessPresent(var MessData: array of Byte; Length: Integer): Boolean;
    function DriverSpeed: Integer;
    procedure GetCANBTx(var CANBT1,CANBT2,CANBT3,CANGCON: Byte);
    procedure SendCanData(MCx: Integer);
    procedure StopCanData(MCx: Integer);
    procedure InitCanClick(Sender: TObject);
    procedure DisableCanClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function DecodeID(IDT1,IDT2,IDT3,IDT4,CONCH: Integer; var RTR, IDE: Boolean): Integer;
    procedure CodeID(ID: Integer; RTR: Boolean; var IDT1,IDT2,IDT3,IDT4: Integer);
    procedure OneWireSetCaptions(Index: Integer);
    procedure CanErrorInc(Val: Byte);
    procedure CanErrorClear;
    procedure CanErrorShow;
    procedure btnPauseClick(Sender: TObject);
    procedure ErrorMessages(Text: String);
    procedure ReceiveData(Index: Integer);
    procedure CanCountShow;
    procedure DisableTransmit;
    procedure btnClearClick(Sender: TObject);
    procedure btnSend0Click(Sender: TObject);
    procedure btnStop0Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure LowSpeedClick(Sender: TObject);
    procedure HighSpeedClick(Sender: TObject);
    procedure OneWireClick(Sender: TObject);
    procedure OneWireMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

 {
  Mozne nastaveni
  Pamet Filtru .... AverageDataTime
  }
implementation

uses D2XXUnit,unitThread,unitMy;

const
  Administrator=False;
  AppName='CAN start  ';
  Version='V1.2';
  INI_FILE='CanStart.INI';
  cSpeedCount=10;
  cAdaptorResponse: array[0..10] of String =('Adaptor Ready','CAN Initialization','MC Initialization','OUT Initialization','Time Initialization','Res','CAN Disable','MC Disable','OUT Disable','Res','Pause');
  cMessTime: array[0..8] of Integer = (5000,2500,2000,1250,1000,500,250,125,2000);
  cCanSpeed: array [0..cSpeedCount,0..3,0..3] of Byte =
    {(50%),    (62,5%),   (75%),      (87,5%)}
  (((49,0,5,7),(49,0,7,5),(49,2,7,3),(49,4,7,1)), {10Baud 0} {BRP,PRS,PHS1,PHS2}
   ((24,0,5,7),(24,0,7,5),(24,2,7,3),(24,4,7,1)), {20Baud 1}
   ((14,0,5,7),(14,0,7,5),(14,2,7,3),(14,4,7,1)), {33Baud 2}
   ((9,0,5,7),(9,0,7,5),(9,2,7,3),(9,4,7,1)),     {50Baud 3}
   ((5,0,5,7),(5,0,7,5),(9,2,7,3),(5,4,7,1)),     {83Baud 4}
   ((4,0,5,7),(4,0,7,5),(5,2,7,3),(4,4,7,1)),     {100Baud 5}
   ((3,0,5,7),(3,0,7,5),(3,2,7,3),(3,4,7,1)),     {125Baud 6}
   ((1,0,5,7),(1,0,7,5),(1,2,7,3),(1,4,7,1)),     {250Baud 7}
   ((0,0,5,7),(0,0,7,5),(0,2,7,3),(0,4,7,1)),     {500Baud 8}
   ((0,0,2,4),(0,0,3,3),(0,0,4,2),(0,4,1,1)),     {800Baud 9}
   ((0,0,1,3),(0,0,2,2),(0,0,3,1),(0,3,1,0)));    {1000Baud 10}

  //   0       1      2      3         4    5
  // START1,START2,CONTROL,LENGTH,DATA,END1,END2

  cSTART1=$FA;
  cSTART2=$F5;
  cEND1=$AF;
  cEND2=$5F;

  cPosSTART1=$00;
  cPosSTART2=$01;
  cPosCONTROL=$02;
  cPosLENGTH=$03;
  cPosData=$04;
  cPosCRC=$04;
  cPosEND1=$05;
  cPosEND2=$06;
  cMessLen=$07;

  cWholeLen=23;

  cReady = $00;
  cInitCan =$01;		  // Initialization CAN driver
  cInitMC0_7 = $02;	  // Initialization MC0-MC7
  cInitMC8_14	=	$03;	// Initialization MC8-MC14
  cInitTime =	$04;		// Initialization Time
  cDisCan	 	=	$06;		// Disable CAN driver
  cDisMC0_7	=	$07;		// Disable M0 - MC7 (Receive)
  cDisMC8_14 = $08;	  // Disable M8 - MC14 (Tranceive)
  cPause		=	$0A;	  // Pause receive and transceive
  dRxCanToUSB = $0B;  // Receive Can Data
  dTxCanToUSB = $0C;  // Transceive Can Data
  dErrToUSB = $0D;    // Can Error

  cMaxFault=3;        // Maximum repeat request
  cTimeOut=4;         // Message timeout

var
  FilePath: String;
  FullPath: String;
  DevicePresent : Boolean;
  MessBuff: array [0..65535,0..255] of byte;
  MessPos: Integer;

  CountBuff: array [0..2,0..16383] of integer;
  AverBuff: array [0..16383] of real;
  CountPos: Integer;

  NoPos: Integer;
  NoBuff: array [0..16383] of byte;

  ErrStuff: Integer;
  ErrCRC: Integer;
  ErrForm: Integer;
  ErrAck: Integer;

  ZDataArray: array [0..255] of byte;
  ZTransfer: Boolean;
  ZTypeMessage: Integer;
  ZTimeOut: Integer;
  ZLenData: Integer;
  ZFault: Boolean;
  Zok: Boolean;

  iFindStart: Integer;

  Pause: Boolean;

  CanDataPos: Integer;
  ReceiveCount: Integer=0;

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
var INIFile: TIniFile;
    INIPath: String;
begin
  Application.HintHidePause:=5000;
  MessPos:=0;
  NoPos:=0;
  iFindStart:=1;
  // INI file
  INIPath:=ExtractFilePath(Application.ExeName);
  INIFile:=TIniFile.Create(INIPath+INI_FILE);
  FilePath:=INIFile.ReadString('PATH','File',INIPath);
  FullPath:=INIFile.ReadString('PATH','Ini','');
  ComboSpeed.ItemIndex:=INIFile.ReadInteger('CAN','Speed',5);
  ListeningCheckBox.Checked:=INIFile.ReadBool('CAN','Listening',False);
  editTag.Text:=INIFile.ReadString('CAN','Tag','0');
  editMask.Text:=INIFile.ReadString('CAN','Mask','0');
  rb2_0A.Checked:=INIFile.ReadBool('CAN','2.0A',True);
  rb2_0B.Checked:= not rb2_0A.Checked;
  INIFile.Free;
  TEventThread.Create(False);
end;

procedure TfrmMain.FormShow(Sender: TObject);
var S : String;
    x: Integer;
begin
  FT_Enable_Error_Report := True; // Error reporting = on
  SaveDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  DevicePresent := False;
  FTSendFile.Enabled := False;
  FTReceiveFile.Enabled := False;
  FTPort_Configure.Enabled := False;
  Timer1.Enabled := True;
  FTSendFile.enabled := False;
  FTReceiveFile.Enabled := False;
  FTResend.Enabled := False;
  SndRxvCmp.Enabled := False;
  GetFTDeviceCount;
  S := IntToStr(FT_Device_Count);
  Caption := AppName+Version;
end;

procedure TfrmMain.CanCountClear;
begin
  CanDataPos:=0;
end;

// Show Message count value
procedure TfrmMain.CanCountShow;
begin
  lblMessCount.Caption:=IntToStr(CanDataPos);
end;

// Show error text
procedure TfrmMain.ErrorMessages(Text: String);
begin
  StatusBar1.Panels[1].Text:=Text;
end;

// Error counters Clear
procedure TfrmMain.CanErrorClear;
begin
  ErrStuff:=0;
  ErrCRC:=0;
  ErrForm:=0;
  ErrAck:=0;
end;

// Error counters Increment
procedure TfrmMain.CanErrorInc(Val: Byte);
begin
  if (Val and $08)=$08 then Inc(ErrStuff);
  if (Val and $04)=$04 then Inc(ErrCRC);
  if (Val and $02)=$02 then Inc(ErrForm);
  if (Val and $01)=$01 then Inc(ErrAck);
end;

// Error counters Show value
procedure TfrmMain.CanErrorShow;
begin
  lblMessError.Caption:=IntToStr(ErrStuff+ErrCRC+ErrForm+ErrAck);
  lblMessError.Hint:='Stuff: '+IntToStr(ErrStuff)+', CRC: '+IntToStr(ErrCRC)+', Form: '+IntToStr(ErrForm)+', Ack: '+IntToStr(ErrAck);
end;

// Time To String Conversion
function sDecodeTime(Hour, Min, Sec, Msec: Integer): string;
begin
  result:=IntToStr(Hour)+':'+sTwo(Min)+':'+sTwo(Sec)+'.'+sThree(Msec);
end;

// Data Byte array to String Conversion
function sDecodeData(Data: array of Byte; Count: Integer): string;
var Len,x: Integer;
    s: string;
begin
  s:='';
  if Count>8 then Count:=8;
  for x:=0 to Count-1 do s:=s+IntToHex(Data[x],2)+'  ';
  result:=s;
end;

// Receive Message Show
// Hour,Min,Sec,Msec ... Receive Message Time [0..23],[0..59],[0..59],[0.999]
// RTR .... Transmit Data Frame(RTR=False)/Remote Frame(RTR=True)
// ID  .... CAN idetifier
// Count .. Receive Data Count
// bData .. Receive Data byte array
procedure TfrmMain.ReceiveCanData(Hour,Min,Sec,Msec: Integer; RTR: Boolean; ID,Count: Integer; Data: array of Byte);
begin
  lblTime.Caption:=sDecodeTime(Hour,Min,Sec,Msec);
  lblID.Caption:=IntToHex(ID,8);
  lblData.Caption:=sDecodeData(Data,Count);
end;

function TfrmMain.DriverSpeed: Integer;
begin
  if LowSpeed.Checked then result:=$01                           // Low Speed
  else if HighSpeed.Checked then result:=$02                     // High Speed
  else if OneWire.Checked and(OneWireType.Tag=1)then result:=$C4 // One Wire (Normal)
  else if OneWire.Checked and(OneWireType.Tag=2)then result:=$44 // One Wire (High)
  else if OneWire.Checked and(OneWireType.Tag=3)then result:=$84 // One Wire (Wake)
  else result:=$02;
end;

// Decode ID from procesor Register IDT1,IDT2,IDT3,IDT4
function TfrmMain.DecodeID(IDT1,IDT2,IDT3,IDT4,CONCH: Integer; var RTR, IDE: Boolean): Integer;
begin
  IDE:=(CONCH and $10 = $10);	
  if not IDE then result:=(IDT1 shl 3)+(IDT2 shr 5)
  else result:=(IDT1 shl 21)+(IDT2 shl 13)+(IDT3 shl 5)+(IDT4 shr 3);
  RTR := ((IDT4 and $04) = $04);
end;

// Code ID for procesor Register IDT1,IDT2,IDT3,IDT4
procedure TfrmMain.CodeID(ID: Integer; RTR: Boolean; var IDT1,IDT2,IDT3,IDT4: Integer);
begin
  if rb2_0A.Checked then
  begin
    IDT1:=((ID and $7F8) shr 3);
    IDT2:=((ID and $007) shl 5);
    IDT3:=0;
    IDT4:=0;
  end
  else
  begin
    IDT1:=((ID and $1FE00000) shr 21);
    IDT2:=((ID and $001FE000) shr 13);
    IDT3:=((ID and $00001FE0) shr 5);
    IDT4:=((ID and $0000001F) shl 3);
  end;
  if RTR then IDT4:=IDT4 + $04;
end;

// Decode All message
// Test procesor Message (Start and CRC code)
// Flow Control (Receive Frame, Receive Error, Receive Acknowledgment)
procedure TfrmMain.DecodeMessage(Data: array of Byte);
var Hour, Min, Sec, Msec, ID, CountData, x: Integer;
    RTR,IDE: Boolean;
begin
  // Test Start1,Start2,CRC
  if(Data[cPosSTART1]=$FA)and(Data[cPosSTART2]=$F5)and((CRC(Data,cPosCONTROL,Data[cPosLENGTH]+cPosCRC)=0))then
  begin
    // Flow Control
    case Data[cPosCONTROL] of
      // Show Receive Frame
      dRxCanToUSB,dTxCanToUSB:
      begin
        if not Pause then
        begin
          Hour:=Data[5];
          Min:=Data[6];
          Sec:=Data[7];
          MSec:=256*Data[8]+Data[9];
          // Test True Time
          if TestTime(Hour,Min,Sec,Msec)then
          begin         // CANIDT1, CANIDT2, CANIDT3, CANIDT4,CONCH
            ID:=DecodeID(Data[10],Data[11],Data[12],Data[13],Data[14],RTR,IDE);
            CountData:=Data[14];
            for x:=0 to 7 do Data[x]:=Data[15+x]; // Receive Data
            // Show receive message
            ReceiveCanData(Hour,Min,Sec,Msec,RTR,ID,CountData,Data);
            // Inc Counter ID
            Inc(CanDataPos);
            CanCountShow;
          end;
        end;
      end;
      // Show CAN Errors
      dErrToUSB:
      begin
        CanErrorInc(Data[cPosData]);
        CanErrorShow;
      end
      // Show Acknowledgment
      else StatusBar1.Panels.Items[1].Text:='  '+cAdaptorResponse[Data[cPosCONTROL]];
    end;
  end;
end;

// Setting processor Register CANBT1,CANBT2,CANBT3 a CANCONCH
// Communication Speed
// Listening mode
procedure TfrmMain.GetCANBTx(var CANBT1,CANBT2,CANBT3,CANGCON: Byte);
const PosIndex=1;  // 67,5%
var SpeedIndex: Integer;
begin
  SpeedIndex:=ComboSpeed.ItemIndex;
  if SpeedIndex<0 then SpeedIndex:=5;
  CANBT1:=cCanSpeed[SpeedIndex][PosIndex][0] shl 1;        // BRP
  CANBT2:=cCanSpeed[SpeedIndex][PosIndex][1] shl 1;        // PRS
  CANBT3:=0;                                               // SMP
  CANBT3:=CANBT3+cCanSpeed[SpeedIndex][PosIndex][2] shl 1; // PHS1
  CANBT3:=CANBT3+cCanSpeed[SpeedIndex][PosIndex][3] shl 4; // PHS2
  if ListeningCheckBox.Checked then
  begin
    CANGCON:=$0A;          // Listening Mode and Autobaude
    DisableTransmit;
    Delay(100);
    btnTransmit0.Enabled:=False;
  end
  else
  begin
   CANGCON:=$02;
   btnTransmit0.Enabled:=True;;
  end;
end;

// Main initialize CAN link
// Test Ready
// Set time from actual time your PC
// Initialize Global Register Driver
// Initialize Receive Message Center
procedure TfrmMain.InitCanClick(Sender: TObject);
var CANBT1,CANBT2,CANBT3,CANGCON: Byte;
    Data: array [0..255] of byte;
    Hour, Min, Sec, MSec: Word;
    ID1,ID2,ID3,ID4,IM1,IM2,IM3,IM4,CONCH: Integer;
begin
  if DevicePresent then
  begin
    // Test Ready
    CreateMessage(cReady,$00,Data);
    Delay(100);

    // Set time from actual time your PC
    DecodeTime(Now, Hour, Min, Sec, MSec);
    Data[0]:=Hour;
    Data[1]:=Min;
    Data[2]:=Sec;
    Data[3]:=Msec div 256;
    Data[4]:=Msec mod 256;
    CreateMessage(cInitTime,$05,Data);
    Delay(100);

    // Initialize Global Register Driver
    GetCANBTx(CANBT1,CANBT2,CANBT3,CANGCON);
    Data[0]:=CANBT1;  // CANBT1
    Data[1]:=CANBT2;  // CANBT2
    Data[2]:=CANBT3;  // CANBT3
    Data[3]:=CANGCON; // CANGCON
    Data[4]:=$32;     // CANGIE
    Data[5]:=DriverSpeed;
    CreateMessage(cInitCAN,$06,Data);
    Delay(100);

    // Initialize Receive Message Center
    CodeID(HexToInt(editTag.Text),FALSE,ID1,ID2,ID3,ID4);
    CodeID(HexToInt(editMask.Text),FALSE,IM1,IM2,IM3,IM4);
    if rb2_0A.Checked then CONCH:=$08 else CONCH:=$18;

    Data[0]:=$00;    // MCx [0..6]
    Data[1]:=ID1;    // CANIDT1
    Data[2]:=ID2;    // CANIDT2
    Data[3]:=ID3;    // CANIDT3
    Data[4]:=ID4;    // CANIDT4
    Data[5]:=IM1;    // CANIDM1
    Data[6]:=IM2;    // CANIDM2
    Data[7]:=IM3;    // CANIDM3
    Data[8]:=IM4;    // CANIDM4
    Data[9]:=CONCH;  // CANCONCH (2.0A/2.0B + Length)
    CreateMessage(cInitMC0_7,$0A,Data);

    Pause:=False;
  end
  else Application.MessageBox('Device Not Present! You must Plug-In USB Adaptor or '+#13#10+'Instal USB Driver and Restart your Computer.','Warning',MB_Ok+MB_ICONWARNING);
end;

// Main Disable CAN link
// Disable Transmit MC
// Disable Receive MC
// Disable CAN driver
procedure TfrmMain.DisableCanClick(Sender: TObject);
var Data: array [0..255] of byte;
begin
  if DevicePresent then
  begin
    // MCx Disable Transmit (0..7) [0..7]
    DisableTransmit;
    Delay(100);

    // MCx Disable Receive (0) [0..6]
    Data[0]:=0;
    CreateMessage(cDisMC0_7,$01,Data);
    Delay(100);

    // Disable Global Register
    CreateMessage(cDisCAN,$0,Data);
    Delay(100);
    Pause := False;
  end
  else Application.MessageBox('Device Not Present! You must Plug-In USB Adaptor or '+#13#10+'Instal USB Driver and Restart your Computer.','Warning',MB_Ok+MB_ICONWARNING);
end;

// Data Transmit to CAN link
// MCx .... Message Center [0..7]
// Per .... Transmit Periode(Delay) [0..65525][ms]
// Sys .... Transmit Mode (1..One Transmit (time delay = per[ms]), 3..Periodic Transmit (period = per[ms]), 4..Imediately Transmit (no time delay), All + 8 .. Receive Transmit Frame
// RTR .... Transmit Data Frame(RTR=False)/Remote Frame(RTR=True)
// ID  .... CAN idetifier
// Count .. Transmit Data Count
// bData .. Transmit Data byte array
procedure TfrmMain.TransmitCanData(MCx,Per,Sys: Integer; RTR: Boolean; ID,Count: Integer; bData: array of Byte);
var Data: array [0..255] of byte;
    ID1,ID2,ID3,ID4,CONCH,x:Integer;
begin    // RTR=True -> Remote FRAME
  if rb2_0A.Checked then CONCH:=$00 else CONCH:=$10;
  CodeID(ID,RTR,ID1,ID2,ID3,ID4);
  // Transmit CAN data
  Data[0]:=MCx;         // MCx  [0..7]
  Data[1]:=Per div 256; // PerH [0..65535]
  Data[2]:=Per mod 256; // PerL
  Data[3]:=Sys;         // Sys  1..One Transmit (time delay = per[ms]), 3..Periodic Transmit (period = per[ms]), 4..Imediately Transmit (no time delay), +8..Receive transmit Frame
  Data[4]:=ID1;         // ID1
  Data[5]:=ID2;         // ID2
  Data[6]:=ID3;         // ID3
  Data[7]:=ID4;         // ID4
  Data[8]:=CONCH+Count; // Length
  for x:=0 to Count-1 do Data[9+x]:=bData[x];
  CreateMessage(cInitMC8_14,$11,Data);
end;

// Config Transmit from Transmit Box
// MCx = Message Centrum [0..7]
procedure TfrmMain.SendCanData(MCx: Integer);
var Data: array [0..255] of byte;
    Count,ID,Per,Sys: Integer;
    RTR: Boolean;
begin
  if DevicePresent then
  begin
    try
      // Period(Delay) Time [0..65535][ms]
      Per:=StrToInt(editTime.Text);
      // Once(Sys=1),Periodic(Sys=3) or Imediately(Sys=4) Transmit Frame, Show Transmit Frame (Sys=Sys+8);
      if PeriodBox.Checked then Sys:=3 else Sys:=1;
      if ShowFrame.Checked then Sys:=Sys+$08;
      // Data(RTR=FALSE) or Remote(RTR=TRUE) Frame
      RTR:=RTRBox.Checked;
      // ID setting
      ID:=HexToInt(editID.Text);
      // Data and Count
      Count:=HexToArray(editData.Text,Data);
      // Transmit data to CAN Link
      TransmitCanData(MCx,Per,Sys,RTR,ID,Count,Data);
    except
      Application.MessageBox('Convert data Error!','ERROR',MB_Ok+MB_ICONERROR);
    end;
  end
  else Application.MessageBox('Device Not Present! You must Plug-In USB Adaptor or '+#13#10+'Instal USB Driver and Restart your Computer.','Warning',MB_Ok+MB_ICONWARNING);
end;

// Stop transmit data
// MCx = Message Centrum [0..7]
procedure TfrmMain.StopCanData(MCx: Integer);
var Data: array [0..255] of byte;
begin
  if DevicePresent then
  begin
    // MCx = Message Centrum [0..7]
    Data[0]:=MCx;         // MCx
    CreateMessage(cDisMC8_14,$01,Data);
  end
  else Application.MessageBox('Device Not Present! You must Plug-In USB Adaptor or '+#13#10+'Instal USB Driver and Restart your Computer.','Warning',MB_Ok+MB_ICONWARNING);
end;

// Disable transmit data
procedure TfrmMain.DisableTransmit;
begin
  if DevicePresent then
  begin
    // Stop Transmit Data in Message Centrum 0..7
    StopCanData(0);
    StopCanData(1);
    StopCanData(2);
    StopCanData(3);
    StopCanData(4);
    StopCanData(5);
    StopCanData(6);
    StopCanData(7);
  end;
end;

// Pause On/Off
procedure TfrmMain.btnPauseClick(Sender: TObject);
var Data: array [0..255] of byte;
begin
  if DevicePresent then
  begin
    Pause := not Pause;
    if Pause then Data[0]:=$FF
    else Data[0]:=0;
    CreateMessage(cPause,$01,Data);
  end
  else Application.MessageBox('Device Not Present! You must Plug-In USB Adaptor or '+#13#10+'Instal USB Driver and Restart your Computer.','Warning',MB_Ok+MB_ICONWARNING);
end;

// Clear count message
procedure TfrmMain.btnClearClick(Sender: TObject);
begin
  CanCountClear;
  CanCountShow;
  CanErrorClear;
  CanErrorShow;
end;

// Create messages for transfer data
function TfrmMain.CreateMessage(TypeMessage, LenData: Integer; DataArray: array of Byte): Boolean;
var x: Integer;
begin
  if DevicePresent then
  begin
    FT_Enable_Error_Report := True;   // Enable Error Reporting
    Timer1.Enabled := False;          // Stop Polling for Device Present

    ZTransfer:=True;                  // Budou vysilana data
    if(LenData>32)then LenData:=32;   // Omezeni delky zpravy
    ZLenData:=LenData;                // Ulozeni delky
    ZTypeMessage:=TypeMessage;        // Typ zpravy
    ZFault:=False;                    // Nulovani chyby zpravy
    Zok:=False;                       // Nulovani skutecneho prichodu zpravy
    ZTimeOut:=cTimeOut;               // TimeOut zpravy
    FT_Out_Buffer[cPosSTART1] := cStart1;
    FT_Out_Buffer[cPosSTART2] := cStart2;
    FT_Out_Buffer[cPosCONTROL] := TypeMessage;
    FT_Out_Buffer[cPosLENGTH] := LenData;
    for x:=0 to LenData-1 do ZDataArray[x]:=DataArray[x];
    for x:=0 to LenData-1 do FT_Out_Buffer[cPosData+x]:=DataArray[x];
    FT_Out_Buffer[cPosCRC+LenData]  := CRC(FT_Out_Buffer,cPosCONTROL,cPosCRC+LenData-1);
    FT_Out_Buffer[cPosEND1+LenData] := cEnd1;
    FT_Out_Buffer[cPosEND2+LenData] := cEnd2;
    x := Write_USB_Device_Buffer(cMessLen+LenData);
    Timer1.Enabled := True;           // Resume Polling for Device Present
    result := (x = cMessLen+LenData);
  end
  else result:=False;
end;

// Multiple open Adaptors to single PC
function Open_USB_Adaptor: FT_Result;
var Serial_Number: string;
    PortStatus: FT_Result;
    DeviceCount: Integer;
    DeviceIndex: DWord;
begin
  result:=FT_NONE;
  GetFTDeviceCount;
  DeviceCount:=FT_Device_Count;
  if FT_Device_Count > 0 then
  begin
    for DeviceIndex:=0 to DeviceCount-1 do
    begin
      GetFTDeviceSerialNo(DeviceIndex);
      Serial_Number:=FT_Device_String;
      result:=Open_USB_Device_By_Serial_Number(Serial_Number);
      if result = FT_OK then break;
    end;
  end;
end;

// Timer for device detect T=55ms
procedure TfrmMain.Timer1Timer(Sender: TObject);
var PortStatus : FT_Result;
begin
  FT_Enable_Error_Report := False; // Turn off error dialog
  If Not DevicePresent then
  begin
    PortStatus := Close_USB_Device; // In case device was already open
    PortStatus := Open_USB_Adaptor;  // Try and open device
    If PortStatus = FT_OK then      // Device is Now Present !
    begin
      DevicePresent := True;
      Caption := AppName+Version+'  -  Device Present';
      FTPort_Configure.Enabled := True;
      FTSendFile.Enabled := True;
      FTReceiveFile.Enabled := True;
      Reset_USB_Device;     // warning - this will destroy any pending data.
      Set_USB_Device_TimeOuts(10,10); // read and write timeouts = 10mS [1..500][ms]
    end;
  end
  else
  begin
    PortStatus := Get_USB_Device_QueueStatus;
    If PortStatus <> FT_OK then
    begin   // Device has been Unplugged
      DevicePresent := False;
      Caption := AppName+Version+'  -  No Device Present';
      FTSendFile.Enabled := False;
      FTReceiveFile.Enabled := False;
      FTPort_Configure.Enabled := False;
    end;
  end;
end;

// Separate Save messages
procedure TfrmMain.SaveMessage(var MessData: array of Byte; Length: Integer);
var x,ActPos: Integer;
    TempData: array [0..65535] of Byte;
    MessDetect: array [0..255] of Byte;
begin
  ActPos:=0;
  if NoPos>1000 then NoPos:=0;
  for x:=0 to NoPos do TempData[x]:=NoBuff[x];
  for x:=0 to Length-1 do TempData[x+NoPos+1]:=MessData[x];
  Length:=Length+NoPos;
  while MessIdent(TempData,MessDetect,ActPos,NoPos,Length) do
  begin
    for x:=0 to 255 do MessBuff[MessPos][x]:=MessDetect[x];
    Inc(MessPos);
  end;
  //NoPos:=cWholeLen;
  //for x:=0 to NoPos do NoBuff[x]:=TempData[Length-NoPos+x];
end;

// Message identfication
function TfrmMain.MessIdent(var MessData: array of Byte; var MessDetect: array of Byte; var ActPos, NoPos: Integer; Length: Integer): Boolean;
var x,Len: Integer;
begin
  NoPos:=0;
  // Finding messages (start1,star2,direction,length,data,end1,end2)
  while((MessData[ActPos+cPosSTART1]<>cSTART1)or(MessData[ActPos+cPosSTART2]<>cSTART2)or
       (MessData[ActPos+MessData[ActPos+cPosLENGTH]+cPosEND1]<>cEND1)or
       (MessData[ActPos+MessData[ActPos+cPosLENGTH]+cPosEND2]<>cEND2))and(ActPos<Length)do
  begin
    inc(ActPos);
    inc(NoPos);
  end;
  // Get length message
  Len:=MessData[ActPos+cPosLENGTH];
  // It's true finding?
  if(ActPos<Length)then
  begin
    for x:=0 to cMessLen+Len-1 do MessDetect[x]:=MessData[ActPos+x];
    ActPos:=ActPos+cMessLen+Len;
    NoPos:=0;
    result:=True;
  end
  else result:=False;
end;

// Message detection
function TfrmMain.MessPresent(var MessData: array of Byte; Length: Integer): Boolean;
begin
  if(MessData[cPosLENGTH]+cMessLen)>=Length then result:=True else result:=False;
end;

// Separate Get messages
function GetMessage(var MessData: array of Byte): Boolean;
var x,y: Integer;
begin
  if MessPos>0 then
  begin
    for x:=0 to 255 do MessData[x]:=MessBuff[0][x];
    for y:=0 to MessPos-1 do
    begin
      for x:=0 to 255 do MessBuff[y][x]:=MessBuff[y+1][x];
    end;
    Dec(MessPos);
    result:=True;
  end
  else result:=False;
end;

// Call from TEvent
procedure TfrmMain.ReceiveData(Index: Integer);
begin
  if DevicePresent then
  begin
    if GetRxDataCount>0 then
    begin
      FTReceiveFileExecute(Self);
      Inc(ReceiveCount);
    end;
  end;
end;

// Receive Data Execute
procedure TfrmMain.FTReceiveFileExecute(Sender: TObject);
var rPom: Real;
    I : Integer;
    Data: array [0..255] of Byte;
begin
  FT_Enable_Error_Report := False;  // Disable Error Reporting
  Timer1.Enabled := False;          // Stop Polling for Device Present
  I := Read_USB_Device_Buffer(FT_In_Buffer_Size);
  SaveMessage(FT_In_Buffer,I);
  while GetMessage(Data) do DecodeMessage(Data);
  Timer1.Enabled := True;           // Resume Polling for Device Present
end;

// USB Driver Close
procedure TfrmMain.FTQuitExecute(Sender: TObject);
begin
  If DevicePresent then Close_USB_Device;
end;

// Start Transmit Data from Message Centrum 0
procedure TfrmMain.btnSend0Click(Sender: TObject);
begin
  SendCanData(0);
end;

// Stop Transmit Data in Message Centrum 0
procedure TfrmMain.btnStop0Click(Sender: TObject);
begin
  StopCanData(0);
end;

// Main window Close
procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var INIFile: TIniFile;
    INIPath: String;
begin
  Pause:=True;
  FTQuitExecute(Self);
// INI file
  INIPath:=ExtractFilePath(Application.ExeName);
  INIFile:=TIniFile.Create(INIPath+INI_FILE);
  INIFile.WriteString('PATH','File',FilePath);
  INIFile.WriteString('PATH','Ini',FullPath);
  INIFile.WriteInteger('CAN','Speed',ComboSpeed.ItemIndex);
  INIFile.WriteBool('CAN','Listening',ListeningCheckBox.Checked);
  INIFile.WriteString('CAN','Tag',editTag.Text);
  INIFile.WriteString('CAN','Mask',editMask.Text);
  INIFile.WriteBool('CAN','2.0A',rb2_0A.Checked);
  INIFile.Free;
end;

// Application Exit
procedure TfrmMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.HighSpeedClick(Sender: TObject);
begin
  OneWireSetCaptions(0);
end;

procedure TfrmMain.LowSpeedClick(Sender: TObject);
begin
  if ComboSpeed.ItemIndex>6 then ComboSpeed.ItemIndex:=6;
  OneWireSetCaptions(0);
end;

procedure TfrmMain.OneWireSetCaptions(Index: Integer);
begin
  case(Index)of
  1: OneWireType.Caption:='Normal';
  2: OneWireType.Caption:='High';
  3: OneWireType.Caption:='Wake';
  else OneWireType.Caption:='';
  end;
  OneWireType.Tag:=Index;
end;

procedure TfrmMain.OneWireClick(Sender: TObject);
begin
  if ComboSpeed.ItemIndex>4 then ComboSpeed.ItemIndex:=4;
  OneWireSetCaptions(OneWireType.Tag);
end;

procedure TfrmMain.OneWireMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if(OneWireType.Tag<3)then OneWireType.Tag:=OneWireType.Tag+1
  else OneWireType.Tag:=1;
  OneWireSetCaptions(OneWireType.Tag);
end;

end.
